<template>
  <b-container class="full-width-container">
    <!--
      We display a special graphic if the user is not logged in,
      or if they haven't submitted any filters yet.
    -->
    <b-container
      v-if="!isAuthenticated || status === LIST_STATUS.EMPTY"
      class="large-container"
    >
      <div class="d-flex justify-content-center no-content">
        <img
          class="mr-4"
          src="../assets/filter-list-banner.svg"
        >
        <div
          class="d-flex flex-column text-justify ml-4"
          style="max-width: 400px;"
        >
          <h1>Find Objects of Interest</h1>
          <span>ANTARES Filters help you sift through ZTF alerts and find what you're looking
            for.</span>
          <b-button
            :to="{ name: 'filterCreate' }"
            class="mt-4"
            variant="primary"
          >
            <span v-if="isAuthenticated">Create your first Filter</span>
            <span v-else>Login to create your first Filter</span>
          </b-button>
        </div>
      </div>
    </b-container>
    <!--
      Otherwise, we use a larger container to display the table of filters
      or an error message--if there was a problem loading their filters.
    -->
    <filter-table-list
      v-else
      :error="error"
      :fetch-filters="fetchFilters"
      :status="status"
      :toggle-filter-visibility="toggleFilterVisibility"
      :visibility-error-msg="visibilityErrorMsg"
    />
  </b-container>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
import Vue from 'vue';
import { mapGetters } from 'vuex';
import { FilterService } from '@/api';
import { Error } from '@/api/client/middleware/error';
import { LIST_STATUS } from '@/common/constants';
import { Filter, RequestQuery } from '@/common/types';
import FilterTableList from '@/components/Filter/TableList.vue';

export default Vue.extend({
  components: {
    FilterTableList,
  },

  data() {
    return {
      error: {},
      LIST_STATUS,
      status: LIST_STATUS.LOADING,
      visibilityErrorMsg: '',
    };
  },

  computed: {
    ...mapGetters(['isAuthenticated', 'user']),
  },

  methods: {
    async fetchFilters(query: Partial<RequestQuery>) {
      this.status = LIST_STATUS.LOADING;
      try {
        const response = await FilterService.listUserFilters(this.user.id, query);
        const { meta: { count } } = response;
        this.status = count === 0 ? LIST_STATUS.EMPTY : LIST_STATUS.SUCCESS;
        return response;
      } catch (errors) {
        const { 0: error } = errors as Error[]; // errors obj has indexed keys but it's not an array
        this.error = error;
        this.status = LIST_STATUS.ERROR;
      }
      return null;
    },
    async toggleFilterVisibility(filter: Filter): Promise<boolean> {
      const toggleFn = filter.public ? FilterService.makePublic : FilterService.makePrivate;
      try {
        await toggleFn(filter.id);
        this.visibilityErrorMsg = '';
        return true;
      } catch (errors) {
        const { 0: error } = errors as Error[]; // errors obj has indexed keys but it's not an array
        this.visibilityErrorMsg = JSON.stringify(error, null, 2);
        return false;
      }
    },
  },
});
</script>

<style scoped>
.no-content {
  margin-top: 100px;
}
</style>
